package com.izouma.awesomeadmin.web;

import java.util.*;

import com.izouma.awesomeadmin.util.ExportExcelUtil;
import org.apache.commons.lang.StringUtils;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.CreditRating;
import com.izouma.awesomeadmin.service.CreditRatingService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
*  controller类
*/
@Controller
@RequestMapping("/creditRating")
@RequiresAuthentication
public class CreditRatingController {

    @Autowired
    private CreditRatingService creditRatingService;

    /**
    * <p>获取全部记录。</p>
    */
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(CreditRating record) {
        List<CreditRating> pp = creditRatingService.getCreditRatingList(record);
        return new Result(true, pp);
    }

    /**
    * <p>根据Id。</p>
    */
    @RequestMapping(value = "/getCreditRating", method = RequestMethod.GET)
    @ResponseBody
    public Result getCreditRating(@RequestParam(required = false, value = "id") String id) {
        CreditRating data = creditRatingService.getCreditRatingById(id);
        return new Result(true, data);
    }

    /**
    * <p>根据条件获取。</p>
    */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(CreditRating record) {
        CreditRating data = creditRatingService.getCreditRating(record);
        return new Result(true, data);
    }


    /**
    * <p>分页查询。</p>
    */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, CreditRating record) {
        Map<String, Object> result = new HashMap<>();

        List<CreditRating> pp =creditRatingService.getCreditRatingByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
    * <p>保存。</p>
    */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(CreditRating record) {
        boolean num = creditRatingService.createCreditRating(record);
        if (num) {
        return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>更新信息。</p>
    */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateCreditRating(CreditRating record) {
        boolean num = creditRatingService.updateCreditRating(record);
        if (num) {
        return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>删除。</p>
    */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteCreditRating(CreditRating record) {

        boolean num = creditRatingService.deleteCreditRating(record);
        if (num) {
        return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }

    /**
    * 导出Excel
    * @param request
    * @param response
    * @param record
    * @throws Exception
    */
    @RequestMapping(value = "/exportExcel", method = RequestMethod.GET)
    @ResponseBody
    public void exportExcel(HttpServletRequest request, HttpServletResponse response, CreditRating record) throws Exception {

    List<CreditRating> creditRatings = creditRatingService.getCreditRatingList(record);


        String sheetName = "credit_rating";
        String titleName = "信用等级数据表";
        String fileName = "信用等级表";
        int columnNumber = 9;
        int[] columnWidth = { 20,  20,  20,  20,  20,  20,  20,  20,  20 };
        String[] columnName = {  "" ,   "删除标识" ,   "更新时间" ,   "更新人" ,   "创建时间" ,   "创建人" ,   "等级" ,   "备注" ,   "排序"  };
        String[][] dataList = new String[creditRatings.size()][9];

        for (int i = 0; i < creditRatings.size(); i++) {

                        dataList[i][0] = String.valueOf(creditRatings.get(i).getId());
                        dataList[i][1] = String.valueOf(creditRatings.get(i).getDelFlag());
                        dataList[i][2] = String.valueOf(creditRatings.get(i).getUpdateTime());
                        dataList[i][3] = String.valueOf(creditRatings.get(i).getUpdateUser());
                        dataList[i][4] = String.valueOf(creditRatings.get(i).getCreateTime());
                        dataList[i][5] = String.valueOf(creditRatings.get(i).getCreateUser());
                        dataList[i][6] = String.valueOf(creditRatings.get(i).getCredit());
                        dataList[i][7] = String.valueOf(creditRatings.get(i).getRemark());
                        dataList[i][8] = String.valueOf(creditRatings.get(i).getRank());
                    }


        ExportExcelUtil.ExportWithResponse(sheetName, titleName, fileName,
        columnNumber, columnWidth, columnName, dataList, response);


        }
    }

